import React from 'react'
import { currentTheme, ThemePicker, useThemePicker } from '../../index'
import css from './style.module.scss'

const themes = {
  light: () => import('./style.light.module.scss'),
  dark: () => import('./style.dark.module.scss')
}

export default function Component () {
  return <>
    <ThemePicker themes={themes}>{({ loading, error, style: themeCSS }) => {
      return <div className={[css.component, themeCSS.component].join(' ')}>
        <p>Switch theme demo via CSS Module</p>
        {loading && `Loading ${currentTheme()} theme`}
        {error && `Can't load ${currentTheme()} theme`}
      </div>
    }}</ThemePicker>
  </>
}

export function Component2 () {
  const { loading, error, style: themeCSS } = useThemePicker(themes)
  return <>
    <div className={[css.component, themeCSS.component].join(' ')}>
      <p>Switch theme demo via CSS Module and using useTheme hook</p>
      {loading && `Loading ${currentTheme()} theme`}
      {error && `Can't load ${currentTheme()} theme`}
    </div>
  </>
}
