# 主题切换组件
共四个用例涵盖常见样式系统需求：
- [使用css module，主题按需加载用例](./examples/CSSModule)
- [使用纯css，主题按需加载用例](./examples/CSSModule)
- [使用css module单样式文件用例](./examples/CombinedCSSModule)
- [使用纯css单样式文件用例](./examples/CombinedPlainCSS)

样式书写模式一点建议：

针对按需加载场景，对于组件来说如果两种主题代码量并不多，其实也可以选择写到一起。
如果单文件内部是按照共享样式、主题1样式、主题2样式...类似这种分开书写的方式，
那么将来也会很方便进行多文件拆分不同主题代码，来切换到按需加载

# 使用用户操作系统主题偏好
代办事项：
特性
- [ ] 监听系统主题切换事件，触发出题修改行为
- [ ] 实现useTheme react hook，简化ThemeLoader组件使用体验
缺陷
- [x] 单样式文件用例无法正常初始化默认样式

相关文章：
- https://web.dev/prefers-color-scheme/
- https://github.com/GoogleChromeLabs/dark-mode-toggle

# API Docs
Coming soon...

# Q & A
#### 每个组件都有调用addTheme方法，这些添加进加载队列的css文件加载函数，是如何防止重复加载的？
是通过对类似函数() => import()进行toString()作为键名防止重复添加，通关判断Promise是否已经完成
来防止重复加载。

比较有意思的地方是，不同的组件中某些加载函数源码可能完全相同，但并没有影响彼此。
这是因为webpack在编译后，给每个chunk都建立了唯一id。以下我截取一部分编译后的代码：
```js
var g = {
    light: function() {
        return n.e(20).then(n.t.bind(null, "1srq", 7))
    },
    dark: function() {
        return n.e(19).then(n.t.bind(null, "Le6d", 7))
    }
};
```
只要引用的文件不是同一个，那么上段编译后的代码里面的hash就是不同的。
